// pages/balance/balance.js
var miyapay = require("../../utils/miyapay4.js");

Page({

  /**
   * 页面的初始数据
   */
  data: {
    payPriceYuan:"0.01",
    show: false,
    scanPayError:"",
    saasid: "",
    marketId: "",
    posId: "",
    cashierCode: "",
    baseUrl: null,
    signKey: "",
  },
  

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
     this.initData();
  },

  /**
   * 初始化数据
   */
  initData(){

    var localAccountInfo = getApp().globalData.localAccountInfo;
    console.info("localAccountInfo==>" + JSON.stringify(localAccountInfo));
    if (localAccountInfo.code == 200 && localAccountInfo.data != null) {
      this.data.saasid = localAccountInfo.data.store.saasid;
      if (localAccountInfo.data.store.marketid != null) {
        this.data.marketId = localAccountInfo.data.store.marketid;
      } else {
        this.data.marketId = localAccountInfo.data.store.storeId;
      }
      this.data.posId = localAccountInfo.data.store.posId;
      this.data.cashierCode = localAccountInfo.data.store.operatorId;
      this.data.signKey = localAccountInfo.data.store.miyaPayPlatformSignKey;
      this.data.baseUrl = localAccountInfo.data.store.miyaPayPlatformUrl;
      this.data.apiVersion = localAccountInfo.data.store.miyaPayApiVersion;
      console.log('1112')
      if (getApp().globalData.useTestPayInfo == true) {
        //just for test
        this.data.signKey = "nbz9ww27sx4ou6dkr61mf63tth3s6e2d";
        this.data.saasid = "miya";
        this.data.marketId = "slzf";
        this.data.posId = "1";
        this.data.cashierCode = "1";
        this.data.baseUrl = "https://miniprograms-165.miyapay.com/miya/miyapay_response.action";
      }
    }
  },



  /**
   * 刷脸支付
   */
  facePay: function () {
    var that = this;
    // 只允许从相机扫码
    wx.scanCode({
      onlyFromCamera: true,
      success(res) {
        if(null != res && res.result != null && res.result!== ''){
          that.doPay(res.result)
        }
      }
    })
  },

  /**
   * 扫码支付
   */
  scanPay:function(){
    this.setData({
      show:true
    }) 
  },

 
  /**
   * 请求支付
   */ 
  doPay:function(payCode){
    wx.showLoading({
      title: '请稍后...',
    })
    //todo
    var orderNo = (new Date()).getTime() + "";
    var tempThis = this;
    miyapay.requestPay({
      baseUrl: this.data.baseUrl,
      type: miyapay.TYPE_BARCODE_PAY,
      saasid: this.data.saasid,
      marketId: this.data.marketId,
      posId: this.data.posId,
      cashierCode: this.data.cashierCode,
      version: "1.5",
      orderNo: orderNo,
      token: payCode,
      payPrice:miyapay.yuan2Fen(this.data.payPriceYuan),
      signKey: this.data.signKey,
      callback: (res) => {
        wx.hideLoading({
          success: (res) => {},
        })

        console.log("支付回调==>" + JSON.stringify(res));
        if (res.code == 0) {
          //支付成功
          tempThis.paySuccess();
        } else {
          tempThis.payFail(res.data);
        }
      }
    });
  },

   /**
    * 支付成功
    */
   paySuccess(){
    wx.showToast({
      title: "支付成功",
      icon: 'success',
      duration: 2000
    })
    wx.redirectTo({
      url: '/pages/pay_result/pay_result?payPriceYuan='+this.data.payPriceYuan+"&description=支付成功",
    })
   },

   /**
    * 支付失败
    */
   payFail(msg) {

     if (this.data.show) {
       this.setData({
         scanPayError: msg
       })
     } else {
       wx.showToast({
         title: msg,
         icon: 'none',
         duration: 2000
       })
     }

   }


})