// pages/refund/refund.js
var {throttle} = require('../../miniprogram_npm/throttle-debounce/index.cjs.js')
var miyapay = require("../../utils/miyapay4.js");

Page({

  /**
   * 页面的初始数据
   */
  data: {
    saasid: "",
    marketId: "",
    posId: "",
    cashierCode: "",
    // 支付平台地址
    baseUrl: null,
    signKey: "",
    apiVersion:""
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.initData()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    //声明监听扫码器
    // wxfaceapp.listenCodePayment({
    //   success(res){
    //     //被扫码回调事件
    //     wxfaceapp.onCodePayEvent(function (res) {
    //       console.log("onCodePayEvent retCode = " + res.replyCode)
    //       //被扫码到的具体的码
    //       console.log("onCodePayEvent code scanned = " + res.code)
    //       //去退款
    //       startRefund(res.code)
    //     })
    //   }
    // })

    //被扫码回调事件，just for test
    wx.scanCode({
      onlyFromCamera: true,
      success (res) {
        console.log(res)
        startRefund(res.result)
      }
    })
        
    
  },

  onImageClicked:function(){
    wx.redirectTo({
      url: '/pages/pay_result/pay_result?isSuccess=false&type=1',
    })
  },

  /**
   * 初始化数据
   */
  initData(){

    var localAccountInfo = getApp().globalData.localAccountInfo;
    console.info("localAccountInfo==>" + JSON.stringify(localAccountInfo));
    if (localAccountInfo != null && localAccountInfo.success == true && localAccountInfo.data != null) {
      this.data.saasid = localAccountInfo.data.store.saasid;
      if (localAccountInfo.data.store.marketid != null) {
        this.data.marketId = localAccountInfo.data.store.marketid;
      } else {
        this.data.marketId = localAccountInfo.data.store.storeId;
      }
      this.data.posId = localAccountInfo.data.store.posId;
      this.data.cashierCode = localAccountInfo.data.store.operatorId;
      this.data.signKey = localAccountInfo.data.store.miyaPayPlatformSignKey;
      this.data.baseUrl = localAccountInfo.data.store.miyaPayPlatformUrl + "";
      this.data.apiVersion = localAccountInfo.data.store.miyaPayApiVersion;
      if (getApp().globalData.useTestPayInfo == true) {
        //just for test
        this.data.signKey = "nbz9ww27sx4ou6dkr61mf63tth3s6e2d";
        this.data.saasid = "miya";
        this.data.marketId = "slzf";
        this.data.posId = "1";
        this.data.cashierCode = "1";
        this.data.baseUrl = "https://paytest.miyapay.com/miya/miyapay_response.action";
      }
    }
  },

  startRefund:function(orderNo){
    miyapay.refund({
      baseUrl: this.data.baseUrl,
      saasid: this.data.saasid,
      marketId: this.data.marketId,
      posId: this.data.posId,
      cashierCode: this.data.cashierCode,
      version: this.data.apiVersion,
      orderNo: this.data.orderNo,
      refundNo: this.data.refundNo,
      refundPrice: this.data.refundPriceFen + "",
      signKey: this.data.signKey,
      callback: (response) => {
        if (response.code == 0) {
          //跳转页面
          var payPriceYuan = miyapay.fen2Yuan(response.data.C7)
          wx.redirectTo({
            url: '/pages/pay_result/pay_result?isSuccess=true&payPriceYuan='+payPriceYuan,
          })
        } else {
          //提示报错
          wx.redirectTo({
            url: '/pages/pay_result/pay_result?isSuccess=false&failedReason='+response.data,
          })
        }
      }
    });

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  onCloseClicked:function(){
    wx.navigateBack()
  }
})